#include"BSP.h"

// ----------- abstract method ------------>>>
void abstract(unsigned char abs)   
{
	LCD_DATA_CLR = LCD_DATA_MASK & 0x0000F000;
	LCD_DATA_SET |= LCD_DATA_MASK & ((abs & 0x000000F0)<<8);	  // Write MSB first

	LCD_CTRL_SET = LCDEN;             		// => E = 1
	Delay_ms(1);
	LCD_CTRL_CLR = LCDEN;             		// => E = 0
	Delay_ms(1);

	LCD_DATA_CLR = LCD_DATA_MASK & 0x0000F000; // Make P3.4 to P3.7 zero
	LCD_DATA_SET |= LCD_DATA_MASK & (((abs<<4) & 0x000000F0)<<8); // Write Lower nibble of data

	LCD_CTRL_SET = LCDEN;             		// => E = 1
	Delay_ms(1);
	LCD_CTRL_CLR = LCDEN;             		// => E = 0
}
// ----------- LCD Port Configuraton
void LCD_PORT_Config()
{
  GPIO_Config = 0x00000000;	//port0 GPIO
  LCD_CTRL_DIR |= ( LCDEN | LCDRS);
  LCD_CTRL_CLR |= ( LCDEN | LCDRS);	
  LCD_DATA_DIR |= LCD_DATA_MASK;
}
// ----------- write command to LCD
void LCD_CMD(unsigned char cmd)
{
	LCD_CTRL_CLR = LCDRS;
	LCD_CTRL_CLR = LCDEN; 
	abstract(cmd);
}
// ----------- position cursor 
void POSITION_CURSOR(unsigned short x, unsigned short y)
{
	unsigned short temp;
	temp = 0x7F + y;
	if (x == 2) 
		temp = temp + 0x40;
	LCD_CMD(temp);
}
// ----------- write data to LCD
void LCD_DATA(unsigned char dta)
{
	LCD_CTRL_SET = LCDRS;
	LCD_CTRL_CLR = LCDEN; 
	abstract(dta);
}
// ----------- write sngle character to LCD
// Note - POSITION_CURSOR must be called before using this function
void LCD_OUT_CH(unsigned char x)
{
	LCD_DATA(x);
}
// ----------- write text
void LCD_OUT_TXT(unsigned char *str)
{
	while(*str)
		LCD_OUT_CH(*str++);
}
// ----------- initializaton procedure
void LCD_INIT()
{
	// ---------- below code for 4 bit mode set
	LCD_DATA_CLR = LCD_DATA_MASK & 0x0000F000;	// MakEN OUT.4 to OUT.7 zENro
	LCD_DATA_SET |= LCD_DATA_MASK & 0x00003000;   // Write 0x3
	
	LCD_CTRL_SET = LCDEN;               	// => EN = 1
	Delay_ms(1);
	LCD_CTRL_CLR = LCDEN;               	// => EN = 0
	Delay_ms(1);

    LCD_DATA_CLR = LCD_DATA_MASK & 0x0000F000;	// MakEN OUT.4 to OUT.7 zENro
	LCD_DATA_SET |= LCD_DATA_MASK & 0x00002000; 	// Write 0x2
	
	LCD_CTRL_SET = LCDEN;               	// => EN = 1
	Delay_ms(1);
	LCD_CTRL_CLR = LCDEN;               	// => EN = 0
	Delay_ms(1);

	// ---------- function set
	LCD_CMD(0x28);    //function set
    LCD_CMD(0x0c);    //display on,cursor off,blink off
    LCD_CMD(0x01);    //clear display
    LCD_CMD(0x06);    //entry mode, set increment
}



