#include"BSP.h"

void Read_Write_Command(unsigned int ad, unsigned short n)
{
	unsigned char cmd, addr;
	if(n) cmd = READ_BYTE;
	else cmd = BYTE_WRITE;
	if(ad & 0x100) 
		cmd |= (1<<3);
	addr = ad;
	SPI0_Tx(cmd);
	SPI0_Tx(addr);
}
unsigned char Read_25LC040()
{
	unsigned char rd;
	rd = SPI0_Rx();
	return rd;
}

void Write_25LC040(unsigned char data)
{
	SPI0_Tx(data);
}

void Write_String_25LC040(unsigned char *str)
{
	while(*str)
		Write_25LC040(*str++);	
}

void Write_Enable(unsigned short rt)
{
	unsigned char cmd;
	if(rt) cmd = WRITE_EN;
	else cmd = WRITE_DIS;
	SPI0_Tx(cmd);
}

unsigned char Status_Reg(unsigned char sr, unsigned char stat)
{
	unsigned char cmd, t=0;
	if(sr)
	{
		cmd = READ_STAT_REG;
		SPI0_Tx(cmd);
		t = SPI0_Rx();
	}
	else
	{
		cmd = WRITE_STAT_REG;
		SPI0_Tx(cmd);
		SPI0_Tx(stat);
		t = 0;
	} 
	return t;
}


